<?php
/*
Plugin Name: CTL Arcade
Plugin URI: http://www.codethislab.com/
Description: This premium Add-on allows you to install and manage games in your wordpress site.
Version: 1.1
Author: 20script
Author URI: http://www.20script.ir
License: GPL
Copyright: Code This Lab srl
*/

    require_once("config.php");
    require_once("db.php");
    require_once("pages/manage-games.php");
    require_once("pages/settings.php");
    require_once("pages/company.php");
    require_once("front/fb.php");
	require_once("front/tw.php");
    require_once("front/shortcodes.php");
	
    function ctl_arcade_remove_qs_var($url, $varname) {
        return preg_replace('/([?&])'.$varname.'=[^&]+(&|$)/','$1',$url);
    }

    function ctl_arcade_menu() {
        add_menu_page(
            CTL_ARCADE_PLUGIN_NAME, CTL_ARCADE_PLUGIN_NAME, 'manage_options', 'ctl_arcade_main_menu',
            "ctl_arcade_load_page" , "none");

        add_submenu_page( 'ctl_arcade_main_menu', "Settings", "Settings", 'manage_options',
            'ctl_arcade_main_menu', "ctl_arcade_load_page" );
        add_submenu_page( 'ctl_arcade_main_menu', "Manage Games", "Manage Games", 'manage_options',
            'ctl_arcade_page_manage_games', 'ctl_arcade_load_page' );

        add_submenu_page( 'ctl_arcade_main_menu', "Documentation", "Documentation", 'manage_options',
            'ctl_arcade_page_documentation', 'ctl_arcade_load_page' );

        add_submenu_page( 'ctl_arcade_main_menu', "About us", "About us", 'manage_options',
            'ctl_arcade_page_company', 'ctl_arcade_load_page' );
    }

    function ctl_arcade_load_page(){

        if ( !current_user_can( 'manage_options' ) )  {
            wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
        }

        $page = filter_input(INPUT_GET, 'page');

        switch ($page) {
            case 'ctl_arcade_main_menu':{
                ctl_arcade_page_settings();
            }break;
            case 'ctl_arcade_page_manage_games':{
                ctl_arcade_page_manage_games();
            }break;
            case 'ctl_arcade_page_documentation':{
                ?>
                <script>
                    window.location.href = '<?php echo plugins_url() . "/ctl-arcade/docs/index.html" ?>';
                </script>
                <?php
            }break;
            case 'ctl_arcade_page_company':{
                ctl_arcade_page_company();
            }break;
        }
    }

    function ctl_arcade_plugin_front_styles_and_scripts(){
        // css
      /*  wp_register_style( 'ctl-arcade-font-oswald', 'https://fonts.googleapis.com/css?family=Oswald');
        wp_register_style( 'ctl-arcade-font-droid-serif', 'https://fonts.googleapis.com/css?family=Droid+Serif:400,
        700'); */
        wp_register_style( 'ctl-arcade-style-front-commons', plugins_url( '/css/commons.css', __FILE__ ) );
        wp_register_style( 'ctl-arcade-style-front-animation', plugins_url( '/css/animation.css', __FILE__ ) );
        wp_register_style( 'ctl-arcade-style-front-dingbats', plugins_url( '/css/ctl-arcade.css', __FILE__ ) );

        /*
        wp_enqueue_style( 'ctl-arcade-font-oswald' );
        wp_enqueue_style( 'ctl-arcade-font-droid-serif' );
        */
        wp_enqueue_style( 'ctl-arcade-style-front-commons' );
        wp_enqueue_style( 'ctl-arcade-style-front-animation' );
        wp_enqueue_style( 'ctl-arcade-style-front-dingbats' );

        // js
        wp_register_script( 'ctl-arcade-script-front-commons', plugins_url( '/js/commons.js', __FILE__ ), array(
            'jquery') );
        wp_register_script( 'ctl-arcade-script-front-main', plugins_url( '/js/front-main.js', __FILE__ ), array(
            'jquery') );

        wp_enqueue_script( 'ctl-arcade-script-front-commons' );
        wp_enqueue_script( 'ctl-arcade-script-front-main' );
    }

    function ctl_arcade_plugin_admin_styles_and_scripts(){
        // css
        /*
        wp_register_style( 'ctl-arcade-font-oswald', 'https://fonts.googleapis.com/css?family=Oswald');
        wp_register_style( 'ctl-arcade-font-droid-serif', 'https://fonts.googleapis
        .com/css?family=Droid+Serif:400,700');
        */
        wp_register_style( 'ctl-arcade-style-admin-commons', plugins_url( '/css/commons.css', __FILE__ ) );
        wp_register_style( 'ctl-arcade-style-admin-animation', plugins_url( '/css/animation.css', __FILE__ ) );
        wp_register_style( 'ctl-arcade-style-admin-dingbats', plugins_url( '/css/ctl-arcade.css', __FILE__ ) );
        wp_register_style( 'ctl-arcade-style-admin-main', plugins_url( '/css/admin-main.css', __FILE__ ) );

        /*
        wp_enqueue_style( 'ctl-arcade-font-oswald' );
        wp_enqueue_style( 'ctl-arcade-font-droid-serif' );
        */
        wp_enqueue_style( 'ctl-arcade-style-admin-commons' );
        wp_enqueue_style( 'ctl-arcade-style-admin-animation' );
        wp_enqueue_style( 'ctl-arcade-style-admin-dingbats' );
        wp_enqueue_style( 'ctl-arcade-style-admin-main' );


        // js
        wp_register_script( 'ctl-arcade-script-base64', plugins_url( '/js/base64.min.js', __FILE__ ), array(
            'jquery') );
        wp_register_script( 'ctl-arcade-script-commons', plugins_url( '/js/commons.js', __FILE__ ), array(
            'jquery') );
        wp_register_script( 'ctl-arcade-script-admin-main', plugins_url( '/js/admin-main.js', __FILE__ ), array(
            'jquery')  );
        wp_register_script( 'ctl-arcade-script-front-main', plugins_url( '/js/front-main.js', __FILE__ ), array(
            'jquery') );

        wp_enqueue_script( 'ctl-arcade-script-base64' );
        wp_enqueue_script( 'ctl-arcade-script-commons' );
        wp_enqueue_script( 'ctl-arcade-script-admin-main' );
        wp_enqueue_script( 'ctl-arcade-script-front-main' );
    }


    function ctl_arcade_hook_extra_css() {

        $extraCSS = ctl_arcade_get_extra_css();

        if( strlen($extraCSS) == 0 ){
            return;
        }

        echo "\n";
        echo "<style>";
        echo $extraCSS;
        echo "</style>";
        echo "\n";
    }

    register_activation_hook( __FILE__, 'ctl_arcade_install_db_schema' );
    register_activation_hook( __FILE__, 'ctl_arcade_install_db_data' );
    register_activation_hook( __FILE__, 'ctl_arcade_set_activation_redirect');
    add_action( 'admin_init', 'ctl_activation_redirect' );

    function ctl_arcade_set_activation_redirect(){
        add_option( 'ctl_arcade_do_activation_redirect', true);
    }

    function ctl_activation_redirect() {
        if (get_option( 'ctl_arcade_do_activation_redirect', false)) {
            delete_option( 'ctl_arcade_do_activation_redirect');

            if(!isset($_GET['activate-multi']) &&
                is_admin() &&
                is_plugin_active(CTL_ARCADE_PLUGIN_DIR . "/" .
                    CTL_ARCADE_PLUGIN_DIR . ".php") &&
                filter_input(INPUT_GET, 'action') != "deactivate") {
                wp_redirect(admin_url() .
                    "admin.php?page=ctl_arcade_main_menu" );
            }
        }
    }


    // enqueue front scripts
    add_action( 'wp_enqueue_scripts', 'ctl_arcade_plugin_front_styles_and_scripts' );


    add_action( 'admin_init', 'ctl_arcade_plugin_admin_styles_and_scripts' );
    add_action( 'admin_menu', 'ctl_arcade_menu' );
    add_action( 'plugins_loaded', 'ctl_arcade_update_db_check');


    // Add button to visual editor
    add_action( 'init', 'ctl_arcade_shortcode_init_buttons' );
    function ctl_arcade_shortcode_init_buttons() {
        add_filter( 'mce_external_plugins', 'ctl_arcade_shortcode_add_buttons' );
        add_filter( 'mce_buttons', 'ctl_arcade_shortcode_register_buttons' );
    }

    function ctl_arcade_shortcode_register_buttons( $buttons ) {
        array_push( $buttons,
            'ctl_arcade_shortcode_add_game_iframe',
            'ctl_arcade_shortcode_add_game_rank',
            'ctl_arcade_shortcode_add_game_rating' );
        return $buttons;
    }
    function ctl_arcade_shortcode_add_buttons( $plugin_array ) {
        $plugin_array['ctl_arcade_shortcode_buttons'] = plugins_url( '/js/admin-shortcode-game.js', __FILE__ );
        return $plugin_array;
    }

    function ctl_arcade_print_footer(){
        ?>
        <div class="ctl-arcade-footer-copyright">
            <div>
                <span>Copyright ©</span>
                <span>Code This Lab srl 2009-<?php echo date("Y"); ?></span>
            </div>
            <div>
                <span>VAT IT06367951214</span>
                <span>REA NA810739</span>
            </div>
            <div>
                <span>cap soc. €16'000,00 i.v.</span>
            </div>
            <div>
                <a target="_blank" href="mailto:info@codethislab.com">info@codethislab.com</a>
            </div>
            <div>
                <a target="_blank" href="http://www.codethislab.com">www.codethislab.com</a>
            </div>
        </div>
        <?php
	}
	
	add_shortcode( 'ctl_arcade_game', 'ctl_arcade_print_shortcode' );

    function ctl_arcade_js_global_vars(){
        $szJS = "<script>\n";
        $szJS .=" var g_szCtlArcadeAjax = '".plugins_url()."/ctl-arcade/front/ajax.php';\n";
        $szJS .=" var g_szCtlArcadeColor = '". ctl_arcade_get_rank_style_color() ."';\n";
        $szJS .="</script>\n";

        echo "\n";
        echo $szJS;
        echo "\n";
    }


    function _ctl_arcade_send_to_host( $host, $method='GET', $path='/', $data='', $useragent=0){

        $method = strtoupper($method);

        $fp = fsockopen($host, 80) or die("Unable to open socket");

        fputs($fp, "$method $path HTTP/1.1\r\n");
        fputs($fp, "Host: $host\r\n");
        fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");

        if ($method == 'POST') {
            fputs($fp, "Content-length: " . strlen($data) . "\r\n");
        }

        if ($useragent) {
            fputs($fp, "User-Agent: MSIE\r\n");
        }

        fputs($fp, "Connection: close\r\n\r\n");

        if ($method == 'POST') {
            fputs($fp, $data);
        }

        $buf ="";

        while (!feof($fp)){
            $buf .= fgets($fp,1024);
        }

        fclose($fp);

        return $buf;
    }

    function _ctl_arcade_strip_response_header($source) {

        list($header, $body) = explode("\r\n\r\n", $source, 2);


        if (preg_match('/Transfer\\-Encoding:\\s+chunked\\r\\n/',$header)){
            $aLines = explode("\r\n", $body, PHP_INT_MAX);

            $response = $aLines[1];

        }else {
            $response = $body;
        }


        
        
        return $response;

    }

    add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'ctl_arcade_add_action_links' );

    function ctl_arcade_add_action_links ( $links ) {
        $mylinks = array(
            '<a href="' . admin_url() . 'admin.php?page=ctl_arcade_main_menu">Settings</a>',
            '<a href="' . admin_url() . 'admin.php?page=ctl_arcade_page_manage_games">Manage Games</a>'
        );
        return array_merge( $mylinks, $links );
    }

    add_action( 'wp_head', 'ctl_arcade_js_global_vars' );
    add_action( 'admin_head', 'ctl_arcade_js_global_vars' );

    add_action( 'wp_head', 'ctl_arcade_hook_extra_css' );
    add_action( 'admin_head', 'ctl_arcade_hook_extra_css' );

    add_action( 'wp_footer', 'ctl_arcade_include_fb_js_sdk' );
    add_action( 'admin_footer', 'ctl_arcade_include_fb_js_sdk' );

    add_action( 'wp_footer', 'ctl_arcade_include_tw_js_sdk' );
    add_action( 'admin_footer', 'ctl_arcade_include_tw_js_sdk' );
	
