<?php

    function ctl_arcade_remove_db(){
        global $wpdb;
        $oResult = $wpdb->query( "DROP TABLE IF EXISTS ". CTL_ARCADE_DB_TABLE_SETTINGS );
        $oResult = $wpdb->query( "DROP TABLE IF EXISTS ". CTL_ARCADE_DB_TABLE_GAMES );
        $oResult = $wpdb->query( "DROP TABLE IF EXISTS ". CTL_ARCADE_DB_TABLE_SCORES );
        $oResult = $wpdb->query( "DROP TABLE IF EXISTS ". CTL_ARCADE_DB_TABLE_RATINGS );
    }


    function ctl_arcade_install_db_schema() {
        global $wpdb;
        $installed_ver = get_option( "CTL_ARCADE_PLUGIN_VERSION" );

        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );

        if( ($installed_ver != CTL_ARCADE_PLUGIN_VERSION) ) {

            $charset_collate = $wpdb->get_charset_collate();

            // create table settings
            $sql = "CREATE TABLE ". CTL_ARCADE_DB_TABLE_SETTINGS . " (
                id bigint(20) NOT NULL AUTO_INCREMENT,
                time datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
                option_name varchar(64) CHARACTER SET ascii NOT NULL,
                option_value text CHARACTER SET ascii NOT NULL,
                UNIQUE KEY id (id),
                UNIQUE KEY option_name (option_name)
            ) $charset_collate;";
            dbDelta( $sql );


            // create table games
            $sql = "CREATE TABLE ". CTL_ARCADE_DB_TABLE_GAMES . " (
                id bigint(20) NOT NULL AUTO_INCREMENT,
                time datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
                game_plugin_dir varchar(32) CHARACTER SET ascii NOT NULL,
                game_name varchar(64) CHARACTER SET ascii NOT NULL,
                game_aspect_ratio varchar(5) CHARACTER SET ascii NOT NULL,
                game_settings text CHARACTER SET ascii NOT NULL,
                game_tags text CHARACTER SET ascii NOT NULL,
                game_rating_value_votes bigint DEFAULT 0,
                game_rating_num_votes bigint DEFAULT 0,
                game_rank tinyint(1),
                UNIQUE KEY id (id),
                UNIQUE KEY game_name (game_name)
            ) $charset_collate;";
            dbDelta( $sql );


            // create table game scores
            $sql = "CREATE TABLE ". CTL_ARCADE_DB_TABLE_SCORES . " (
                id bigint(20) NOT NULL AUTO_INCREMENT,
                time datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
                game_plugin_dir varchar(32) CHARACTER SET ascii NOT NULL,
                user_id bigint,
                user_score int,
                UNIQUE KEY id (id)
            ) $charset_collate;";
            dbDelta( $sql );

            // create table game ratings
            $sql = "CREATE TABLE ". CTL_ARCADE_DB_TABLE_RATINGS . " (
                id bigint(20) NOT NULL AUTO_INCREMENT,
                time datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
                game_plugin_dir varchar(32) CHARACTER SET ascii NOT NULL,
                user_id bigint,
                game_rating tinyint(1),
                UNIQUE KEY id (id)
            ) $charset_collate;";
            dbDelta( $sql );

            add_option( 'CTL_ARCADE_PLUGIN_VERSION', CTL_ARCADE_PLUGIN_VERSION );
        }
    }

    function ctl_arcade_install_db_data() {
        global $wpdb;

        // default rank style
        $oResult = $wpdb->insert(
            CTL_ARCADE_DB_TABLE_SETTINGS,
            array(
                'time' => current_time( 'mysql' ),
                'option_name' => CTL_ARCADE_SETTINGS_KEY_RANK_STYLE,
                'option_value' => "green"
            )
        );

        if(!$oResult){
            $wpdb->print_error();
        }

        // default fb app id
        $oResult = $wpdb->insert(
            CTL_ARCADE_DB_TABLE_SETTINGS,
            array(
                'time' => current_time( 'mysql' ),
                'option_name' => CTL_ARCADE_SETTINGS_KEY_FB_APP_ID,
                'option_value' => ""
            )
        );

        if(!$oResult){
            $wpdb->print_error();
        }
		
		// default twitter share
        $oResult = $wpdb->insert(
            CTL_ARCADE_DB_TABLE_SETTINGS,
            array(
                'time' => current_time( 'mysql' ),
                'option_name' => CTL_ARCADE_SETTINGS_KEY_TWITTER_SHARE,
                'option_value' => "0"
            )
        );

        if(!$oResult){
            $wpdb->print_error();
        }

        // default extra css
        $oResult = $wpdb->insert(
            CTL_ARCADE_DB_TABLE_SETTINGS,
            array(
                'time' => current_time( 'mysql' ),
                'option_name' => CTL_ARCADE_SETTINGS_KEY_EXTRA_CSS,
                'option_value' => ""
            )
        );

        if(!$oResult){
            $wpdb->print_error();
        }


        // default ad interlevel code
        $oResult = $wpdb->insert(
            CTL_ARCADE_DB_TABLE_SETTINGS,
            array(
                'time' => current_time( 'mysql' ),
                'option_name' => CTL_ARCADE_SETTINGS_KEY_AD_INTERLEVEL_CODE,
                'option_value' => ""
            )
        );

        if(!$oResult){
            $wpdb->print_error();
        }

        // default ad interlevel min time
        $oResult = $wpdb->insert(
            CTL_ARCADE_DB_TABLE_SETTINGS,
            array(
                'time' => current_time( 'mysql' ),
                'option_name' => CTL_ARCADE_SETTINGS_KEY_AD_INTERLEVEL_MIN_TIME,
                'option_value' => '7'
            )
        );

        if(!$oResult){
            $wpdb->print_error();
        }

        // default ad preloader code
        $oResult = $wpdb->insert(
            CTL_ARCADE_DB_TABLE_SETTINGS,
            array(
                'time' => current_time( 'mysql' ),
                'option_name' => CTL_ARCADE_SETTINGS_KEY_AD_PRELOADER_CODE,
                'option_value' => ""
            )
        );

        if(!$oResult){
            $wpdb->print_error();
        }

        // default ad preloader min time
        $oResult = $wpdb->insert(
            CTL_ARCADE_DB_TABLE_SETTINGS,
            array(
                'time' => current_time( 'mysql' ),
                'option_name' => CTL_ARCADE_SETTINGS_KEY_AD_PRELOADER_MIN_TIME,
                'option_value' => '7'
            )
        );

        if(!$oResult){
            $wpdb->print_error();
        }


        // default min time between ads
        $oResult = $wpdb->insert(
            CTL_ARCADE_DB_TABLE_SETTINGS,
            array(
                'time' => current_time( 'mysql' ),
                'option_name' => CTL_ARCADE_SETTINGS_KEY_MIN_TIME_BETWEEN_ADS,
                'option_value' => "30"
            )
        );

        if(!$oResult){
            $wpdb->print_error();
        }

    }

    function ctl_arcade_update_db_check() {
        if (get_site_option('CTL_ARCADE_PLUGIN_VERSION') != CTL_ARCADE_PLUGIN_VERSION) {
            // there are no update
        }
    }

    function ctl_arcade_get_min_time_between_ads(){
        global $wpdb;

        $oRes = $wpdb->get_results( "SELECT option_value FROM " . CTL_ARCADE_DB_TABLE_SETTINGS . " WHERE option_name = '". CTL_ARCADE_SETTINGS_KEY_MIN_TIME_BETWEEN_ADS ."'" );

        return $oRes[0]->option_value;
    }

    function ctl_arcade_is_ad_interlevel(){
        global $wpdb;
        $oRes = $wpdb->get_results( "SELECT option_value FROM " . CTL_ARCADE_DB_TABLE_SETTINGS . " WHERE option_name = '". CTL_ARCADE_SETTINGS_KEY_AD_INTERLEVEL_CODE ."'" );
        if( $oRes[0] && strcmp($oRes[0]->option_value, "") != 0){
            return true;
        }else{
            return false;
        }
    }

    function ctl_arcade_get_ad_interlevel_min_time(){
        global $wpdb;

        $oRes = $wpdb->get_results( "SELECT option_value FROM " . CTL_ARCADE_DB_TABLE_SETTINGS . " WHERE option_name = '". CTL_ARCADE_SETTINGS_KEY_AD_INTERLEVEL_MIN_TIME ."'" );

        return $oRes[0]->option_value;
    }

    function ctl_arcade_get_ad_interlevel(){
        global $wpdb;


        $oRes = $wpdb->get_results(
            "SELECT option_name,option_value FROM " . CTL_ARCADE_DB_TABLE_SETTINGS . " WHERE".
            " option_name =
'". CTL_ARCADE_SETTINGS_KEY_AD_INTERLEVEL_CODE ."' OR" .
            " option_name = '". CTL_ARCADE_SETTINGS_KEY_AD_INTERLEVEL_MIN_TIME ."'" );

        $oData = array();
        foreach($oRes as $oRow){
            $oData[$oRow->option_name] = $oRow->option_value;
        }

        return $oData;
    }

    function ctl_arcade_is_ad_preloader(){
        global $wpdb;
        $oRes = $wpdb->get_results( "SELECT option_value FROM " . CTL_ARCADE_DB_TABLE_SETTINGS . " WHERE option_name = '". CTL_ARCADE_SETTINGS_KEY_AD_PRELOADER_CODE ."'" );
        if( $oRes[0] && strcmp($oRes[0]->option_value, "") != 0){
            return true;
        }else{
            return false;
        }
    }

    function ctl_arcade_get_ad_preloader_min_time(){
        global $wpdb;

        $oRes = $wpdb->get_results( "SELECT option_value FROM " . CTL_ARCADE_DB_TABLE_SETTINGS . " WHERE option_name = '". CTL_ARCADE_SETTINGS_KEY_AD_PRELOADER_MIN_TIME ."'" );

        return $oRes[0]->option_value;
    }

    function ctl_arcade_get_ad_preloader(){
        global $wpdb;

        $oRes = $wpdb->get_results(
            "SELECT option_name,option_value FROM " . CTL_ARCADE_DB_TABLE_SETTINGS . " WHERE".
            " option_name =
'". CTL_ARCADE_SETTINGS_KEY_AD_PRELOADER_CODE ."' OR" .
            "
option_name = '". CTL_ARCADE_SETTINGS_KEY_AD_PRELOADER_MIN_TIME ."'" );


        $oData = array();
        foreach($oRes as $oRow){
            $oData[$oRow->option_name] = $oRow->option_value;
        }

        return $oData;
    }

    function ctl_arcade_get_extra_css(){
        global $wpdb;

        $oRes = $wpdb->get_results( "SELECT option_value FROM " . CTL_ARCADE_DB_TABLE_SETTINGS . " WHERE option_name = '". CTL_ARCADE_SETTINGS_KEY_EXTRA_CSS ."'" );

        return $oRes[0]->option_value;
    }

	function ctl_arcade_get_twitter_share(){
		global $wpdb;
		
		return $wpdb->get_var( "SELECT option_value FROM " . CTL_ARCADE_DB_TABLE_SETTINGS . " WHERE option_name = '". CTL_ARCADE_SETTINGS_KEY_TWITTER_SHARE ."'" );
	};

    function ctl_arcade_get_fb_app_id(){
        global $wpdb;

        $oRes = $wpdb->get_results( "SELECT option_value FROM " . CTL_ARCADE_DB_TABLE_SETTINGS . " WHERE option_name = '". CTL_ARCADE_SETTINGS_KEY_FB_APP_ID ."'" );

        return $oRes[0]->option_value;
    }

    function ctl_arcade_get_rank_style_color(){
        global $wpdb;

        $oRes = $wpdb->get_results( "SELECT option_value FROM " . CTL_ARCADE_DB_TABLE_SETTINGS . " WHERE option_name = '". CTL_ARCADE_SETTINGS_KEY_RANK_STYLE ."'" );

        return $oRes[0]->option_value;
    }
