<?php
    require_once("../../../../wp-load.php");
    require_once("../config.php");

    global $wpdb;

    if( is_plugin_inactive(CTL_ARCADE_PLUGIN_DIR . "/" . CTL_ARCADE_PLUGIN_DIR. ".php")  ){
        echo  "status=false&code=plugininactive&desc=plugin not active";
        die();
    }

    if( !isset($_REQUEST["action"]) ){
        echo "action required";
        exit();
    }

    switch($_REQUEST["action"]){
        case "ad_preloader_code":{
            $oRes = $wpdb->get_results( "SELECT option_value FROM " . CTL_ARCADE_DB_TABLE_SETTINGS . " WHERE option_name = '". CTL_ARCADE_SETTINGS_KEY_AD_PRELOADER_CODE ."'" );
            echo $oRes[0]->option_value;
            exit();
        }break;
        case "ad_interlevel_code":{
            $oRes = $wpdb->get_results( "SELECT option_value FROM " . CTL_ARCADE_DB_TABLE_SETTINGS . " WHERE option_name = '". CTL_ARCADE_SETTINGS_KEY_AD_INTERLEVEL_CODE ."'" );
            echo $oRes[0]->option_value;
            exit();
        }break;
        case "give-rating":{
            if(!get_userdata($_POST["user_id"])){
                echo  "status=false&desc=user not exist";
                die();
            }

            // check if user already voted
            $szQuery = "SELECT * FROM " . CTL_ARCADE_DB_TABLE_RATINGS;
            $szQuery .= " WHERE game_plugin_dir ='".$_POST["game_plugin_dir"] . "' AND user_id = " .$_POST["user_id"] ;
            $aVotes = $wpdb->get_results( $szQuery );

            if(isset($aVotes[0]) && $aVotes[0]){
                echo  "status=false&code=useralreadyvoted&desc=user already gave a rating";
                die();
            }

            $oResult = $wpdb->insert(
                CTL_ARCADE_DB_TABLE_RATINGS,
                array(
                    'time'            => current_time( 'mysql' ),
                    'game_plugin_dir' => $_POST["game_plugin_dir"],
                    'user_id'         => $_POST["user_id"],
                    'game_rating'     => $_POST["game_rating"]
                )
            );

            // increment cached rating
            $szQuery = "UPDATE  " . CTL_ARCADE_DB_TABLE_GAMES;
            $szQuery .= " SET game_rating_value_votes = game_rating_value_votes + " . $_POST["game_rating"] . ", game_rating_num_votes = game_rating_num_votes + 1 WHERE game_plugin_dir ='".$_POST["game_plugin_dir"] ."'";
            $oResult = $wpdb->query( $szQuery );


            echo "status=true";
        }break;
        case "save-score":{
            if(!get_userdata($_POST["user_id"])){
                echo  "status=false&desc=user not exist";
                die();
            }

            $oResult = $wpdb->insert(
                CTL_ARCADE_DB_TABLE_SCORES,
                array(
                    'time'            => current_time( 'mysql' ),
                    'game_plugin_dir' => $_POST["game_plugin_dir"],
                    'user_id'         => $_POST["user_id"],
                    'user_score'      => $_POST["user_score"]
                )
            );
            if(!$oResult){
                echo  "status=false&desc=" . $wpdb->last_error;
                die();
            }
            echo  "status=true";
        }break;
        case "get-rank":{
            if( $_POST["limit"] > 50 ){
                $_POST["limit"] = 50;
            }
            if( $_POST["limit"] < 5 ){
                $_POST["limit"] = 5;
            }

            switch( $_POST["period"]){
                case "weekly":{
                    $period = "AND WEEKOFYEAR(time) = WEEKOFYEAR(NOW())";
                }break;
                case "monthly":{
                    $period = "AND MONTH(time) = MONTH(NOW()) ";
                }break;
                case "all-time":{
                    $period = "";
                }break;
            }


            $szQuery = "SELECT *, MAX(user_score) as user_score FROM " . CTL_ARCADE_DB_TABLE_SCORES;
            $szQuery .= " WHERE game_plugin_dir ='".$_POST["game"];
            $szQuery .= "' $period GROUP BY user_id ORDER BY user_score " . $_POST["order"];
            $szQuery .= " LIMIT 0,".  $_POST["limit"];


            /*
            $szQuery = "SELECT * FROM " . CTL_ARCADE_DB_TABLE_SCORES;
            $szQuery .= " WHERE game_plugin_dir ='".$_POST["game"];
            $szQuery .= "' $period ORDER BY user_score " . $_POST["order"];
            $szQuery .= " LIMIT 0,".  $_POST["limit"];
*/

            $aScores = $wpdb->get_results( $szQuery );

            $aJsonData = array();

            if ( $aScores ){
                foreach( $aScores as $oScore ){
                    
                    $oUser = get_userdata($oScore->user_id);
                    
                    if (!$oUser){
                        continue;
                    }
                    
                    array_push($aJsonData,                     
                            array("display_name" => $oUser->display_name, 
                                  "user_score" => $oScore->user_score, 
                                  "user_id" => $oScore->user_id, 
                                  "time" => $oScore->time  ));
                }                
            }

            echo "status=true&scores=" . json_encode($aJsonData);
        }break;
    }



?>