<?php

    function _ctl_arcade_page_game_page($szGamePluginDir) {
        global $wpdb;

        $oGame = $wpdb->get_results( "SELECT * FROM " . CTL_ARCADE_DB_TABLE_GAMES . " WHERE game_plugin_dir = '". $szGamePluginDir ."'" );

        if(!$oGame){
            ?>
            <script>
                window.top.location = "<?php echo admin_url(); ?>admin.php?page=ctl_arcade_page_manage_games";
            </script>
            <?php
            return false;
        }

        $oGame = $oGame[0];

        $szAction = filter_input(INPUT_GET, 'action');

        switch($szAction){
            case "empty_scores":{
                $wpdb->query( "DELETE FROM ". CTL_ARCADE_DB_TABLE_SCORES . " WHERE game_plugin_dir = '".
                    $szGamePluginDir ."'");

                ?>
                <p class="ctl-arcade-admin-message-green">No scores in DB</p>
                <?php
            }break;
            case "empty_ratings":{
                $wpdb->query( "DELETE FROM ". CTL_ARCADE_DB_TABLE_RATINGS . " WHERE game_plugin_dir = '".
                    $szGamePluginDir ."'");

                $szQuery = "UPDATE  " . CTL_ARCADE_DB_TABLE_GAMES;
                $szQuery .= " SET game_rating_value_votes = 0, game_rating_num_votes = 0 WHERE game_plugin_dir ='".$szGamePluginDir . "'";
                $wpdb->query( $szQuery );

                ?>
                <p class="ctl-arcade-admin-message-green">No ratings in DB</p>
            <?php
            }break;
        }

        ?>
        <h3><?php echo $oGame->game_name; ?></h3>

        <div>
            <img class="ctl-arcade-admin-game-cover" src="<?php echo plugins_url() . "/" . $oGame->game_plugin_dir;
            ?>/images/cover.jpg"/>
        </div>

        <h3>Description</h3>
        <?php
            echo file_get_contents(plugins_url() . "/" . $oGame->game_plugin_dir . "/description.html");
        ?>

        <h3>Status</h3>

        <?php
            if( is_plugin_inactive( $oGame->game_plugin_dir . "/". $oGame->game_plugin_dir .".php")){
                ?>
                <p>Game correctly installed but <strong>disabled</strong>!</p>
                <a class="ctl-arcade-btn ctl-arcade-btn-mini" href="<?php echo
                admin_url(); ?>admin.php?page=ctl_arcade_page_manage_games&game=<?php echo $oGame->game_plugin_dir; ?>&action=activate&sub=game">activate</a>
                <?php
            }else{
                ?>
                <p>Game correctly installed!</p>
                <a class="ctl-arcade-btn ctl-arcade-btn-mini" href="<?php echo
                admin_url(); ?>admin.php?page=ctl_arcade_page_manage_games&game=<?php echo $oGame->game_plugin_dir; ?>&action=deactivate&sub=game">deactivate</a>
                <?php
            }
        ?>


        <h3>Settings</h3>
        <p>Empty all game scores from db</p>
        <a onclick="ctl_arcade_clear_score();" class="ctl-arcade-btn ctl-arcade-btn-mini">empty scores</a>

        <p>Empty all game ratings from db</p>
        <a onclick="ctl_arcade_clear_rating();" class="ctl-arcade-btn ctl-arcade-btn-mini">empty ratings</a>

        <h3>Pictures</h3>

        <section class="ctl-arcade-admin-game-gallery" data-gallery="shots">
            <?php
                for( $i = 0; $i < 3; $i++){
                    $szImg =
                        plugins_url() . "/" . $oGame->game_plugin_dir . "/images/" .
                        $oGame->game_plugin_dir . "-" . $i . ".jpg";
                    ?>
                    <div class="ctl-arcade-admin-game-gallery-item" data-fullsize="<?php echo $szImg; ?>"><img src="<?php echo $szImg; ?>"></div>
                    <?php
                }
            ?>
        </section>

        <h3>Testing</h3>
        <p>Try the game</p>

	<div>
		<strong>Game Shortcode:</strong>
		<textarea>[ctl_arcade_game game="<?php echo $oGame->game_plugin_dir; ?>" mode="iframe" max-height="500"]</textarea>	
	</div>

        <div class="ctl-arcade-game-preview-window">
            <?php
                echo ctl_arcade_print_shortcode(
                    array( "mode" => "iframe", "game" => $oGame->game_plugin_dir ) );
            ?>
        </div>

        <h3>Rating</h3>

	<div>
		<strong>Rating Shortcode:</strong>
		<textarea readonly>[ctl_arcade_game game="<?php echo $oGame->game_plugin_dir; ?>" mode="rating"]</textarea>	
	</div>

        <?php
        echo  ctl_arcade_print_shortcode(
            array( "mode" => "rating",
                   "game" => $oGame->game_plugin_dir) );
        ?>

        <?php
            if( $oGame->game_rank == 1 ){
              ?>
                <h3>Leaderboard</h3>
		<div>
			<strong>Leaderboard Shortcode <small>(period: all-time, weekly, monthly)</small>:</strong>
			<textarea>[ctl_arcade_game game="<?php echo $oGame->game_plugin_dir; ?>" mode="leaderboard" period="all-time" limit="50" order="DESC"]</textarea>	
		</div>
                <?php
                echo  ctl_arcade_print_shortcode(
                    array( "mode" => "leaderboard", "game" => $oGame->game_plugin_dir, "limit" => 50,
                           "period" => "all-time", "order" => "DESC"));
            }
        ?>

        <div class="ctl-arcade-game-settings-btn-wrapper">
            <a href="<?php echo admin_url(); ?>admin.php?page=ctl_arcade_main_menu"
               class="ctl-arcade-btn">plugin settings</a>
            <a href="<?php echo admin_url(); ?>admin.php?page=ctl_arcade_page_manage_games" class="ctl-arcade-btn">games list</a>
            <a href="<?php echo admin_url(); ?>admin.php?page=ctl_arcade_page_company"
               class="ctl-arcade-btn">about us</a>
        </div>


        <script>

            function ctl_arcade_clear_score(){
                if (confirm("Are you sure to empty all game scores from db?\nThis action isn't reversible!")) {
                    window.top.location = "<?php echo admin_url(); ?>"
                    + "admin.php?page=ctl_arcade_page_manage_games&action=empty_scores&game=<?php echo
                    $szGamePluginDir; ?>";
                }
            }

            function ctl_arcade_clear_rating(){
                if (confirm("Are you sure to empty all game ratings from db?\nThis action isn't reversible!")) {
                    window.top.location = "<?php echo admin_url(); ?>"
                    + "admin.php?page=ctl_arcade_page_manage_games&action=empty_ratings&game=<?php echo
                    $szGamePluginDir; ?>";
                }
            }
        </script>

        <?php

    }

    function _ctl_arcade_page_game_list() {
        global $wpdb;

        $aGames = $wpdb->get_results( "SELECT * FROM " . CTL_ARCADE_DB_TABLE_GAMES . " ORDER BY game_name ASC" );
        $iNumGames = count($aGames);
        $aInstalledGames = array();

        if( $iNumGames > 0 ){
            ?>
            <h3>List of installed games ( <?php echo $iNumGames; ?> )</h3>


            <p>Search by tag or name</p>
            <input type="text" placeholder="puzzle..." class="ctl-arcade-installed-game-filter"/>

            <script>
                jQuery(".ctl-arcade-installed-game-filter").on('input', function(){

                    var bFound = false;
                    var szKey = jQuery.trim(jQuery(this).val()).toLowerCase();

                    jQuery(".ctl-arcade-admin-installed-game-list .ctl-arcade-admin-game-preview-box").each(function(){
                        var indexTags = jQuery(this).attr("data-tags").toLowerCase().indexOf(szKey);
                        var indexName = jQuery(this).find("h3").text().toLowerCase().indexOf(szKey);

                        if( indexTags >= 0 || indexName >= 0){
                            jQuery(this).css("display","block");
                            bFound = true;
                        }else{
                            jQuery(this).css("display","none");
                        }
                    });

                    if( bFound == false ){
                        jQuery(".ctl-arcade-admin-installed-game-list-message").text("No results with this key");
                    }else{
                        jQuery(".ctl-arcade-admin-installed-game-list-message").text("");
                    }
                })
            </script>

            <div class="ctl-arcade-admin-game-list ctl-arcade-admin-installed-game-list">
                <?php
                    foreach($aGames as $oGame){

                        $aInstalledGames[$oGame->game_plugin_dir] = true;

                        if( is_plugin_inactive( $oGame->game_plugin_dir . "/". $oGame->game_plugin_dir .".php")){
                            $bGameActive = false;
                        }else{
                            $bGameActive = true;
                        }
                        ?>
                        <div class="ctl-arcade-admin-game-preview-box" data-tags="<?php echo $oGame->game_tags; ?>">
                            <a target="_self" href="<?php echo admin_url(); ?>admin.php?page=ctl_arcade_page_manage_games&game=<?php echo $oGame->game_plugin_dir; ?>">
                                <h3><?php echo $oGame->game_name; ?></h3>
                                <img class="ctl-arcade-traffic-light" src="<?php echo plugins_url() . "/" . CTL_ARCADE_PLUGIN_DIR;?>/images/<?php echo ($bGameActive ? "traffic_light_circle_green.png" : "traffic_light_circle_red.png" ); ?>">
                                <img class="ctl-arcade-admin-game-preview-thumb" src="<?php echo plugins_url() . "/" . $oGame->game_plugin_dir;?>/images/<?php echo $oGame->game_plugin_dir; ?>-icon.png"/>
                            </a>
                            <div class="ctl-arcade-admin-game-preview-box-footer">
                                <?php
                                    if(!$bGameActive){
                                        ?>
                                        <a class="ctl-arcade-btn ctl-arcade-btn-mini" href="<?php echo
                                        admin_url(); ?>admin.php?page=ctl_arcade_page_manage_games&game=<?php echo $oGame->game_plugin_dir; ?>&action=activate&sub=list">activate</a>
                                        <?php
                                    }else{
                                        ?>
                                        <a class="ctl-arcade-btn ctl-arcade-btn-mini" href="<?php echo
                                        admin_url(); ?>admin.php?page=ctl_arcade_page_manage_games&game=<?php echo $oGame->game_plugin_dir; ?>&action=deactivate&sub=list">deactivate</a>
                                    <?php
                                    }
                                ?>
                            </div>
                        </div>
                    <?php
                    }
                ?>
            </div>

            <div class="ctl-clear"></div>

            <div>
                <p class="ctl-arcade-admin-message-red ctl-arcade-admin-installed-game-list-message"></p>
            </div>
        <?php
            }else{

            ?>
            <h3>There are no games installed!</h3>

            <p>Check under "CTL Arcade Games" menu if there are some games to install or buy them from <a href="http://codecanyon.net/collections/5401443-ctl-arcade-plugin/?ref=codethislab" target="_blank">our full catalogue</a></p>

            <?php
        }

       /*
            $aGameFeed = json_decode(
                _ctl_arcade_strip_response_header(
                    _ctl_arcade_send_to_host(
                        "showcase.codethislab.com","GET",
                        "/feeds/ctl-arcade/codecanyon_ctl_arcade_game_feed.php")));

            if( count($aGameFeed)-$iNumGames > 0 ){
                ?>

                <h3>Full Compatible Games (<?php echo count($aGameFeed)-$iNumGames;?>)</h3>
                <p><a target="_blank" href="http://codecanyon.net/collections/5401443-ctl-arcade-plugin/?ref=codethislab">http://codecanyon.net/collections/5401443-ctl-arcade-plugin</a></p>

                <p>Search by tag or name</p>
                <input type="text" placeholder="puzzle..." class="ctl-arcade-new-game-filter"/>

                <script>
                    jQuery(".ctl-arcade-new-game-filter").on('input', function(){

                        var bFound = false;
                        var szKey = jQuery.trim(jQuery(this).val()).toLowerCase();

                        jQuery(".ctl-arcade-admin-new-game-list .ctl-arcade-admin-game-preview-box").each(function(){
                            var indexTags = jQuery(this).attr("data-tags").toLowerCase().indexOf(szKey);
                            var indexName = jQuery(this).find("h3").text().toLowerCase().indexOf(szKey);

                            if( indexTags >= 0 || indexName >= 0){
                                jQuery(this).css("display","block");
                                bFound = true;
                            }else{
                                jQuery(this).css("display","none");
                            }
                        });

                        if( bFound === false ){
                            jQuery(".ctl-arcade-admin-game-list-message").text("No results with this key");
                        }else{
                            jQuery(".ctl-arcade-admin-game-list-message").text("");
                        }
                    });
                </script>

                <div class="ctl-arcade-admin-game-list ctl-arcade-admin-new-game-list">
                    <?php

                        foreach( $aGameFeed as $oGame ){
                            if ( isset($aInstalledGames[$oGame->plugin]) && $aInstalledGames[$oGame->plugin] == true){
                                continue;
                            }
                            ?>
                            <div class="ctl-arcade-admin-game-preview-box" data-tags="<?php echo implode(",",$oGame->tags); ?>">
                                <h3 class="<?php echo ( $oGame->new ? "ctl-arcade-blink-effect" : ""); ?>"><?php echo $oGame->name; ?></h3>
                                <a target="_blank" href="<?php echo $oGame->url; ?>">

                                    <?php
                                        if($oGame->new){
                                            ?>
                                            <div class="ctl-arcade-new-stripe-container">
                                                <img class="ctl-arcade-admin-game-preview-thumb" src="<?php echo $oGame->icon; ?>"/>
                                                <span>new</span>
                                            </div>
                                        <?php
                                        }else{
                                            ?>
                                            <img class="ctl-arcade-admin-game-preview-thumb" src="<?php echo $oGame->icon; ?>"/>
                                        <?php
                                        }
                                    ?>
                                </a>
                                <div class="ctl-arcade-admin-game-preview-box-footer">
                                    <a target="_blank" class="ctl-arcade-btn ctl-arcade-btn-mini" href="<?php echo $oGame->url; ?>">try & buy</a>
                                </div>
                            </div>

                        <?php
                        }

                    ?>
                    <div class="ctl-clear"></div>
                </div>

                <p class="ctl-arcade-admin-message-red ctl-arcade-admin-game-list-message"></p>
                <?php
            }else{*/
                ?>
                <div>
                    <h3 class="ctl-arcade-admin-message-green">New Amazing Games will be soon available, stay tuned!</h3>
                    <p>Check the <a href="http://codecanyon.net/collections/5401443-ctl-arcade-plugin/?ref=codethislab" target="_blank"> full catalogue</a></p>
 
                </div>
                <?php
           // }

        ?>




        <div class="ctl-arcade-game-settings-btn-wrapper">
            <a href="<?php echo admin_url(); ?>admin.php?page=ctl_arcade_main_menu"
               class="ctl-arcade-btn">Plugin settings</a>
            <a href="<?php echo admin_url(); ?>admin.php?page=ctl_arcade_page_company"
               class="ctl-arcade-btn">about us</a>
        </div>

        <?php
    }


    function ctl_arcade_page_manage_games() {

        ?>
        <div class="ctl-arcade-wrapper">
            <?php
           /*    echo  _ctl_arcade_strip_response_header(
                            _ctl_arcade_send_to_host(
                                "showcase.codethislab.com","GET","/feeds/ctl-arcade/ctl_arcade_news.php"));
*/
            ?>
        <h2>Manage Games</h2>
        <?php


        $szGame = filter_input(INPUT_GET, 'game');

        if($szGame){
            $action = filter_input(INPUT_GET, 'action');
            switch($action){
                case "activate":{
                    activate_plugin($szGame . "/" . $szGame . ".php");
                    $sub = filter_input(INPUT_GET, 'sub');
                    if( $sub == "list"){
                        _ctl_arcade_page_game_list();
                    }else{
                        _ctl_arcade_page_game_page($szGame);
                    }
                }break;
                case "deactivate":{
                    deactivate_plugins($szGame . "/" . $szGame . ".php");
                    $sub = filter_input(INPUT_GET, 'sub');
                    if( $sub == "list"){
                        _ctl_arcade_page_game_list();
                    }else{
                        _ctl_arcade_page_game_page($szGame);
                    }
                }break;
                default:{
                    _ctl_arcade_page_game_page($szGame);
                }
            }
        }else{
            _ctl_arcade_page_game_list();
        }

            ctl_arcade_print_footer();
        ?>

        </div>
        <?php
    }

?>