<?php
    require_once("../../../../wp-load.php");
    require_once("../../../../wp-admin/includes/plugin.php");

     global $wpdb;
    $aGames = $wpdb->get_results( "SELECT * FROM " . CTL_ARCADE_DB_TABLE_GAMES . " ORDER BY game_name ASC" );

?>


<!DOCTYPE html>
<html lang="it">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no">

    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Oswald">
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Droid+Serif:400,700">

    <link rel="stylesheet" href="../css/commons.css">
    <link rel="stylesheet" href="../css/admin-main.css">

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.4/jquery.min.js"></script>
</head>
<body class="ctl-arcade-wrapper">

    <div class="ctl-arcade-shortcode-game-iframe-game-filter">
        <label>Digit some letters or choose one game from the list below</label>
        <input type="text">
    </div>

<?php
    if( count($aGames) > 0 ){
?>
        <div class="ctl-arcade-shortcode-game-iframe-gamelist-wrapper">
            <ul>
            <?php
        foreach( $aGames as $oGame ){
            if( is_plugin_inactive( $oGame->game_plugin_dir . "/". $oGame->game_plugin_dir .".php")){
                continue;
            }

            if($_REQUEST["mode"] == "leaderboard" && $oGame->game_rank == 0 ){
                continue;
            }

            ?>
            <li data-game-plugin-dir="<?php echo $oGame->game_plugin_dir; ?>">
                <img width="32"
                     src="<?php echo plugins_url() . "/" . $oGame->game_plugin_dir;?>/images/<?php echo $oGame->game_plugin_dir; ?>-icon.png"/>
                <span><?php echo $oGame->game_name; ?></span>
            </li>
        <?php
        }
?>
            </ul>
            </div>


        <?php

            switch($_REQUEST["mode"]){
                case "rating":{

                }break;
                case "game":{
                    ?>
                    <div class="ctl-arcade-shortcode-game-iframe-game-max-height">
                        <label>Game iframe max height (px)</label>
                        <input type="number" value="1000">
                    </div>
                    <?php
                }break;
                case "leaderboard":{
                    ?>
                    <div class="ctl-arcade-shortcode-game-rank-period">
                        <label>Ranking period</label>
                        <input type="radio" name="period" value="all-time" checked="checked"/>All Time
                        <input type="radio" name="period" value="monthly"/>Monthly
                        <input type="radio" name="period" value="weekly"/>Weekly
                    </div>

                    <div class="ctl-arcade-shortcode-game-rank-limit">
                        <label>Number of scores (max 50)</label>
                        <input type="number" value="10" min="5" max="50">
                    </div>
                    <?php
                }break;
            }
        ?>


        <label>Final shortcode</label>
        <textarea class="ctl-arcade-shortcode-game-iframe-output"></textarea>

        <div class="ctl-arcade-shortcode-game-iframe-gamelist-btn-wrapper">
            <div onclick="ctl_arcade_shortcode_game_iframe_insert()" class="ctl-arcade-btn ctl-arcade-btn-mini">insert</div>
            <div onclick="ctl_arcade_shortcode_game_iframe_close();" class="ctl-arcade-btn ctl-arcade-btn-mini">close</div>
        </div>

            <?php

    }else{
    ?>
        <h3>There are no games installed!</h3>
        <p>Go to the <a target="_self" href="<?php echo admin_url()."plugins.php"; ?>">plugin page</a> to enable games for CTL Arcade Plugin or buy games from <a href="http://codecanyon.net/user/codethislab/portfolio" target="_blank">our full catalogue</a></p>
    <?php
    }
?>

<script>

    jQuery(window).ready(function(){
        jQuery(".ctl-arcade-shortcode-game-iframe-game-filter input").on('input', function(){
            var szKey = jQuery.trim(jQuery(this).val()).toLowerCase();
            var bFound = false;

            jQuery(".ctl-arcade-shortcode-game-iframe-gamelist-wrapper li").each(function(){
                var szGame = jQuery.trim(jQuery(this).text()).toLowerCase();
                var szSrcNameGame = jQuery.trim(jQuery(this).text());

                var index = szGame.indexOf(szKey);
                if( index >= 0 ){

                    var szNewString = szSrcNameGame.substr(0,index) +
                            "<strong>" +  szSrcNameGame.substr(index,szKey.length) + "</strong>" +
                        szSrcNameGame.substr(index+szKey.length, szSrcNameGame.length - (index + szKey.length));

                    bFound = true;

                    jQuery(this).find("span").html(szNewString);
                    jQuery(this).css("display","block");
                }else{
                    jQuery(this).css("display","none");
                }
            });

            if( szKey === "" || !bFound ){
                jQuery(".ctl-arcade-shortcode-game-iframe-output").val('');
            }/*else{
                _ctl_arcade_write_shortcode();
            }*/
        });

        jQuery(".ctl-arcade-shortcode-game-iframe-gamelist-wrapper li").each(function(){
            jQuery(this).on("click",function(){
                
                jQuery(".ctl-arcade-shortcode-game-iframe-game-filter input").val(
                        jQuery(this).find("span").text());
                
                _ctl_arcade_write_shortcode(jQuery(this));
            });
        });

        jQuery(".ctl-arcade-shortcode-game-rank-period input").each(function(){
            jQuery(this).on("change",function(){       

                var szGameName = jQuery(".ctl-arcade-shortcode-game-iframe-game-filter input").val();              
                var bShortcodeUpdated = false;

                jQuery(".ctl-arcade-shortcode-game-iframe-gamelist-wrapper li").each(function(){
                    if( jQuery(this).find("span").text() === szGameName ){
                        _ctl_arcade_write_shortcode(jQuery(this));
                        bShortcodeUpdated = true;                        
                    }                        
                });

                if(bShortcodeUpdated === false){
                    jQuery(".ctl-arcade-shortcode-game-iframe-output").val("");    
                }
            });
        });        
    });


    function _ctl_arcade_write_shortcode(oGame){
        <?php
        switch($_REQUEST["mode"]){
            case "game":{
            ?>
        if(!oGame){
            jQuery(".ctl-arcade-shortcode-game-iframe-output").val('[ctl_arcade_game game="'+ jQuery(".ctl-arcade-shortcode-game-iframe-gamelist-wrapper li:first-child").attr("data-game-plugin-dir") +'" mode="iframe" max-height="'+ jQuery(".ctl-arcade-shortcode-game-iframe-game-max-height input").val() +'"]');
        }else{
            jQuery(".ctl-arcade-shortcode-game-iframe-output").val('[ctl_arcade_game game="'+ oGame.attr("data-game-plugin-dir") +'" mode="iframe" max-height="'+ jQuery(".ctl-arcade-shortcode-game-iframe-game-max-height input").val() +'"]');
        }
            <?php
            }break;
            case "leaderboard":{
            ?>
        if(!oGame){
            jQuery(".ctl-arcade-shortcode-game-iframe-output").val(
                '[ctl_arcade_game game="'+
                jQuery(".ctl-arcade-shortcode-game-iframe-gamelist-wrapper li:first-child").attr("data-game-plugin-dir") +
                '" mode="leaderboard" limit="'+
                jQuery(".ctl-arcade-shortcode-game-rank-limit input").val() +
                '" period="' +
                jQuery("input[name=period]:checked").val() +
                '" order="DESC"]');
        }else{
            jQuery(".ctl-arcade-shortcode-game-iframe-output").val('[ctl_arcade_game game="'+ oGame.attr("data-game-plugin-dir") +'" mode="leaderboard" ' +
            'limit="'+  jQuery(".ctl-arcade-shortcode-game-rank-limit input").val() + '" period="' + jQuery('input[name=period]:checked').val() +'" order="DESC"]');
        }
        <?php
        }break;
            case "rating":{
            ?>
        if(!oGame){
            jQuery(".ctl-arcade-shortcode-game-iframe-output").val(
                '[ctl_arcade_game game="'+
                jQuery(".ctl-arcade-shortcode-game-iframe-gamelist-wrapper li:first-child").attr("data-game-plugin-dir") +
                '" mode="rating"]');
        }else{
            jQuery(".ctl-arcade-shortcode-game-iframe-output").val('[ctl_arcade_game game="'+ oGame.attr("data-game-plugin-dir") +'" mode="rating" ]');
        }
        <?php
        }break;
    }
?>
    }

    function ctl_arcade_shortcode_game_iframe_close(){
        top.tinymce.activeEditor.windowManager.close();
    }

    function ctl_arcade_shortcode_game_iframe_insert(){

        if( jQuery(".ctl-arcade-shortcode-game-iframe-output").val() === "" ){
            return;
        }

        top.tinymce.activeEditor.insertContent( jQuery(".ctl-arcade-shortcode-game-iframe-output").val() );
        top.tinymce.activeEditor.windowManager.close();
    }
</script>

</body>
</html>